#!/bin/sh

# base directory with scripts, experiments etc.
base_dir="/net/matylda4/schwarzp/EXP/TR"

# directory with executables (QuickNet, pfile_utils, feacat, trapper, STK ...)
bin_dir="$base_dir/tools/bin"

# script directory
script_dir="$base_dir/scripts"

# use the temporal directory
use_tmp=0

# local temporal directory
tmp_dir="/tmp/$USER"

# the minimal free space in temporal directory, else the experimental directory is used
tmp_min_space=5000

# use SGE
use_sge=1

# selected computers for SGE
sge_computers=all.q@svatava.fit.vutbr.cz,all.q@svatava.fit.vutbr.cz,all.q@ulrika.fit.vutbr.cz,all.q@ulrika.fit.vutbr.cz,all.q@blade01.fit.vutbr.cz,all.q@blade01.fit.vutbr.cz,all.q@blade02.fit.vutbr.cz,all.q@blade02.fit.vutbr.cz,all.q@blade03.fit.vutbr.cz,all.q@blade03.fit.vutbr.cz,all.q@blade04.fit.vutbr.cz,all.q@blade04.fit.vutbr.cz,all.q@blade05.fit.vutbr.cz,all.q@blade05.fit.vutbr.cz,all.q@blade06.fit.vutbr.cz,all.q@blade06.fit.vutbr.cz,all.q@blade07.fit.vutbr.cz,all.q@blade07.fit.vutbr.cz,all.q@blade08.fit.vutbr.cz,all.q@blade08.fit.vutbr.cz,all.q@blade09.fit.vutbr.cz,all.q@blade09.fit.vutbr.cz,all.q@blade10.fit.vutbr.cz,all.q@blade10.fit.vutbr.cz,all.q@blade11.fit.vutbr.cz,all.q@blade11.fit.vutbr.cz,all.q@blade12.fit.vutbr.cz,all.q@blade12.fit.vutbr.cz,all.q@blade13.fit.vutbr.cz,all.q@blade13.fit.vutbr.cz,all.q@blade14.fit.vutbr.cz,all.q@blade14.fit.vutbr.cz,all.q@blade15.fit.vutbr.cz,all.q@blade15.fit.vutbr.cz,all.q@blade16.fit.vutbr.cz,all.q@blade16.fit.vutbr.cz,all.q@blade17.fit.vutbr.cz,all.q@blade17.fit.vutbr.cz,all.q@blade18.fit.vutbr.cz,all.q@blade19.fit.vutbr.cz,all.q@blade19.fit.vutbr.cz,all.q@blade20.fit.vutbr.cz,all.q@blade20.fit.vutbr.cz,all.q@blade21.fit.vutbr.cz,all.q@blade21.fit.vutbr.cz,all.q@blade22.fit.vutbr.cz,all.q@blade22.fit.vutbr.cz,all.q@blade23.fit.vutbr.cz,all.q@blade23.fit.vutbr.cz,all.q@blade24.fit.vutbr.cz,all.q@blade24.fit.vutbr.cz,all.q@blade25.fit.vutbr.cz,all.q@blade25.fit.vutbr.cz,all.q@blade26.fit.vutbr.cz,all.q@blade26.fit.vutbr.cz,all.q@pcmatejkap.fit.vutbr.cz,all.q@pcschwarzp.fit.vutbr.cz,all.q@pcspeech2.fit.vutbr.cz,all.q@pcspeech4.fit.vutbr.cz,all.q@pcspeech3.fit.vutbr.cz,all.q@pcburget.fit.vutbr.cz,all.q@pcglembek.fit.vutbr.cz,all.q@pckarafiat.fit.vutbr.cz,all.q@pcszoke.fit.vutbr.cz,all.q@pcgrezl.fit.vutbr.cz,all.q@PCN00.fit.vutbr.cz,all.q@PCN01.fit.vutbr.cz,all.q@PCN02.fit.vutbr.cz,all.q@PCN03.fit.vutbr.cz,all.q@PCN05.fit.vutbr.cz,all.q@PCN06.fit.vutbr.cz,all.q@PCN07.fit.vutbr.cz,all.q@PCN08.fit.vutbr.cz,all.q@PCN09.fit.vutbr.cz,all.q@PCN10.fit.vutbr.cz,all.q@PCN11.fit.vutbr.cz,all.q@PCN12.fit.vutbr.cz,all.q@PCN13.fit.vutbr.cz,all.q@PCN14.fit.vutbr.cz,all.q@PCN16.fit.vutbr.cz,all.q@PCN17.fit.vutbr.cz,all.q@PCN18.fit.vutbr.cz,all.q@PCN19.fit.vutbr.cz,all.q@PCN20.fit.vutbr.cz

# selected fast computers for SGE
sge_fast_computers=all.q@svatava.fit.vutbr.cz,all.q@svatava.fit.vutbr.cz,all.q@ulrika.fit.vutbr.cz,all.q@ulrika.fit.vutbr.cz,all.q@blade01.fit.vutbr.cz,all.q@blade01.fit.vutbr.cz,all.q@blade02.fit.vutbr.cz,all.q@blade02.fit.vutbr.cz,all.q@blade03.fit.vutbr.cz,all.q@blade03.fit.vutbr.cz,all.q@blade04.fit.vutbr.cz,all.q@blade04.fit.vutbr.cz,all.q@blade05.fit.vutbr.cz,all.q@blade05.fit.vutbr.cz,all.q@blade06.fit.vutbr.cz,all.q@blade06.fit.vutbr.cz,all.q@blade07.fit.vutbr.cz,all.q@blade07.fit.vutbr.cz,all.q@blade08.fit.vutbr.cz,all.q@blade08.fit.vutbr.cz,all.q@blade09.fit.vutbr.cz,all.q@blade09.fit.vutbr.cz,all.q@blade10.fit.vutbr.cz,all.q@blade10.fit.vutbr.cz,all.q@blade11.fit.vutbr.cz,all.q@blade11.fit.vutbr.cz,all.q@blade12.fit.vutbr.cz,all.q@blade12.fit.vutbr.cz,all.q@blade13.fit.vutbr.cz,all.q@blade13.fit.vutbr.cz,all.q@blade14.fit.vutbr.cz,all.q@blade14.fit.vutbr.cz,all.q@blade15.fit.vutbr.cz,all.q@blade15.fit.vutbr.cz,all.q@blade16.fit.vutbr.cz,all.q@blade16.fit.vutbr.cz,all.q@blade17.fit.vutbr.cz,all.q@blade17.fit.vutbr.cz,all.q@blade18.fit.vutbr.cz,all.q@blade19.fit.vutbr.cz,all.q@blade19.fit.vutbr.cz,all.q@blade20.fit.vutbr.cz,all.q@blade20.fit.vutbr.cz,all.q@blade21.fit.vutbr.cz,all.q@blade21.fit.vutbr.cz,all.q@blade22.fit.vutbr.cz,all.q@blade22.fit.vutbr.cz,all.q@blade23.fit.vutbr.cz,all.q@blade23.fit.vutbr.cz,all.q@blade24.fit.vutbr.cz,all.q@blade24.fit.vutbr.cz,all.q@blade25.fit.vutbr.cz,all.q@blade25.fit.vutbr.cz,all.q@blade26.fit.vutbr.cz,all.q@blade26.fit.vutbr.cz,all.q@pcmatejkap.fit.vutbr.cz,all.q@pcschwarzp.fit.vutbr.cz,all.q@pcspeech2.fit.vutbr.cz,all.q@pcspeech4.fit.vutbr.cz,all.q@pcspeech3.fit.vutbr.cz,all.q@pcburget.fit.vutbr.cz,all.q@pcglembek.fit.vutbr.cz,all.q@pckarafiat.fit.vutbr.cz,all.q@pcszoke.fit.vutbr.cz,all.q@pcgrezl.fit.vutbr.cz,all.q@PCN00.fit.vutbr.cz,all.q@PCN01.fit.vutbr.cz,all.q@PCN02.fit.vutbr.cz,all.q@PCN03.fit.vutbr.cz,all.q@PCN05.fit.vutbr.cz,all.q@PCN06.fit.vutbr.cz,all.q@PCN07.fit.vutbr.cz,all.q@PCN08.fit.vutbr.cz,all.q@PCN09.fit.vutbr.cz,all.q@PCN10.fit.vutbr.cz,all.q@PCN11.fit.vutbr.cz,all.q@PCN12.fit.vutbr.cz,all.q@PCN13.fit.vutbr.cz,all.q@PCN14.fit.vutbr.cz,all.q@PCN16.fit.vutbr.cz,all.q@PCN17.fit.vutbr.cz,all.q@PCN18.fit.vutbr.cz,all.q@PCN19.fit.vutbr.cz,all.q@PCN20.fit.vutbr.cz

# resource for SGE
# mem=1G
# mhz=400MHz
sge_resource="tmp_free=5000,disk_free=5000"

# email for notification if a job is done of aborted
sge_email=$USER@fit.vutbr.cz

# phoneme insertion penalty tuning interval 
penalty_interval="-20 20"

# default phoneme insertion penalty
default_penalty=-4

# tune penalty on the test set
tune_on_test_set=0

# tune on maximal accuracy, else the recognizer is tuned on the equal number of insertion
# and deletion errors
tune_max_acc=1

# stages to run
do_tr_param=1
do_te_param=1
do_cv_param=1
do_train=1
do_test=1
do_cv=1
do_train_fwd=1
do_scoring=1
do_score_tr=1
do_prepare_new_it=1
do_run_new_it=1
do_fwd_bands=1   
do_fwd_merger=1  
do_tr_bands=1    
do_tr_merger=1   
do_tr_vtln=0      # perform SAT-VTLN (speaker adaptive training)
do_te_vtln=0      # perform VTLN during recognition
do_estim_gmm=0    # estimate GMM models - neccessary for VTLN
do_te_vtln_search=1
do_te_vtln_fwd=1

# keep selected files
keep_cv_posteriors=1
keep_test_posteriors=1
keep_train_posteriors=1
keep_train_params=0
keep_test_params=0
keep_cv_params=0
keep_train_band_posteriors=0
keep_train_merged_band_posteriors=0
keep_test_band_posteriors=0
keep_test_merged_band_posteriors=0
keep_cv_band_posteriors=0
keep_cv_merged_band_posteriors=0
keep_lop=0

# use linear merging (should be fixed, does not work now)
use_lin_merging=0

# default definition of parameterisation commands
# for conversion between mel-banks and mfcc or other features

# default language scale factor
lmscale=5

# report also score with bigram LM
score_with_bigram=1
 
# weighting of NN normalization coefficients
# possible values - none | hamming | triang
band_norms_wintype=none
band_norms_nwins=1
merger_norms_wintype=none
merger_norms_nwins=1

# number of states per unit (phoneme)
num_states=1

# file with numbers of states per phoneme 
# (this variable is used if we want to have different numbers of states per phoneme)
num_states_file=""

# realign labels before training (Forward/Backward/...)
realign_labels=0

# maximal number of iteration 
# - the iteration is training and realigment of labels 
max_iterations=1

# if more than one iteraction is done, these directories are used as a source
# of pfiles and class posteriors for realignment
# - do not modify this lines, they are added automaticaly to the configuration script
#   when new iteration is prepared
source_pfile_dir=""
source_ffout_dir=""

# nonlinearities in output layers of neural networks
# - lower nets
tnn_out_nonlinearity=softmax
# - upper nets
mnn_out_nonlinearity=softmax

# vtln parameters
vtln_param="mfccer -op pfile -ip pfile -Cep 12 -C0 "
vtln_min=0.8
vtln_max=1.2
vtln_lfreq=3400
vtln_ufreq=3400
vtln_deltalike=0.001
vtln_ncpu=30
vtln_schedule=0

# NN learning scheduler
# - use default Quicknet scheduler
ts_use_quicknet=1
# - the algorithm divides learning rate by 2 if increment in accuacy between two epochs measured on
#   the training set is smaller then this value
ts_delta_dec=0.5
# - the algorithm stops training if increment in accuracy betweem two epochs measured on
#   the crosvalidation set is smaller then this value
ts_deta_stop=0.5
# - minimal and maximal number of iterations of NN learning
ts_min_it=1
ts_max_it=9999

# to prevent errors with decimal separators in different locales (EN,US - '.' CZ - ',')
LANG=C
