#!/bin/sh

# systems
system="STREAMS"

# experimental directory
exp_dir="LCRC"

# output directory
out_dir="$base_dir/Experiments/${exp_dir}"

# enable/disable temporal directory
use_tmp=1

# enable/disable Sun Grid Engine
# Do you use a cluster of computers. If not, disable this option
use_sge=1

# tune penalty on the test set
tune_on_test_set=0

# maximal number of training iterations (with realignment of labels)
max_iterations=1

# split input labels to N states
# if 1 is set, no splitting is performed
num_states=1

# tune phoneme insertion penalty (on CV set) to maximal accuracy, 
# else the equal number of insertion and deletion errors is tuned
tune_max_acc=1

# to do - stages that are run
# - parameterization
do_tr_param=1
do_te_param=1
do_cv_param=1
# - training of NNs, forward pass of test set, forward pass of CV set 
do_train=1
do_test=1
do_cv=1
# - forward pass of training set
do_train_fwd=1
# - forward pass through lower nets
do_fwd_bands=1
# - forward pass through merger
do_fwd_merger=1
# - run scoring
do_scoring=1
# - prepare new iteration of training (creates new experimental directory $out_dir/itX)
do_prepare_new_it=1
# - run new iteration if the maximal number has not been reached
do_run_new_it=0

# keep following files
keep_test_posteriors=0
keep_cv_posteriors=0
keep_train_posteriors=0
keep_train_params=0
keep_test_params=0
keep_cv_params=0
keep_train_band_posteriors=0
keep_train_merged_band_posteriors=0
keep_test_band_posteriors=0
keep_test_merged_band_posteriors=0

# base directory with pfiles - the directory an output of 'create_pfile' package
pfile_dir=/mnt/matylda4/schwarzp/EXP/create_pfiles/out/new_timit_0-16k_23mel_1st_al

# train, test and crossvalidation pfile for band classifiers
train_tnn=${pfile_dir}/pfiles/train.pfile
test_tnn=${pfile_dir}/pfiles/test.pfile
cv_tnn=${pfile_dir}/pfiles/cv.pfile

# reference mlf
ref_mlf=${pfile_dir}/mlfs/ref.mlf

# the dictionary
dict=${pfile_dir}/dicts/dict

# list of train, test and crossvalidation file names
train_list=$pfile_dir/lists/train.scp
test_list=$pfile_dir/lists/test.scp
cv_list=$pfile_dir/lists/cv.scp

# number of sentences for training
len=2.8
if [ "$len" = "0.5" ] ; then
    tnn_train_sents=587
elif [ "$len" = "1" ] ; then
    tnn_train_sents=1184
elif [ "$len" = "1.5" ] ; then
    tnn_train_sents=1766
elif [ "$len" = "2" ] ; then
    tnn_train_sents=2361
elif [ "$len" = "2.5" ] ; then
    tnn_train_sents=2949
elif [ "$len" = "2.8" ] ; then
    tnn_train_sents=3296
fi

# number of sentences for crossvalidation
tnn_cv_sents=400

# window width for lower nets
window_width=1

# number of neurons in the hidden layer of lower nets
num_hidden_band=500

# number of output classes
num_classes=40

# number of training sentences for merger
mnn_train_sents=$tnn_train_sents

# number of crossvalidation sentences for merger
mnn_cv_sents=$tnn_cv_sents

# window width for merger
mnn_window_width=1

# number of neurons in hidden layer of merger
num_hidden_merger=500

# number of output classes for merger
mnn_num_classes=$num_classes

# parameterization commands for different lower nets
mfccer[1]="trapper -op pfile -ip pfile -Crb 0:22 -Lc 15 -Rc 0 -w ${base_dir}/other/windows/hamming_lc15 -DCT 10 -C0"
mfccer[2]="trapper -op pfile -ip pfile -Crb 0:22 -Lc 0 -Rc 15 -w ${base_dir}/other/windows/hamming_rc15 -DCT 10 -C0"

# is there the lower net?
is_net[1]=1
is_net[2]=1

# transformation taken at each output of lower nets
transform[1]=log
transform[2]=log

# transformation taken at the concatinated outputs of lower nets
final_tr=
