#!/usr/bin/perl

if($ARGV[0] eq "" || $ARGV[1] eq "")
{
    print "SYNTAX: extractMLFLevel.pl MLF level\n";
    exit(1);
}

$level = $ARGV[1];

open MLF, "$ARGV[0]" or "Can not open the MLF: $ARGV[0]";

$header = <MLF>;
chomp $header;

print "The file is not MLF: $ARGV[0]" if($header ne "#!MLF!#");

print "$header\n";

while($file = <MLF>)
{
    chomp $file;
    print "$file\n";
    $plabel = "";
    do
    {
	$l = <MLF>;
	chomp $l;
	$l =~ s/^ +//;
	$l =~ s/ +$//;
	if($l ne ".")
	{
	    @arr = split /\s+/, $l;
	    $start = $arr[0];
	    $stop = $arr[1];
	    
	    if($arr[4] ne "")
	    {
		if($arr[4] =~ /.*\-(.+)\+.*/)
		{
		    $arr[4] = $1;
		}
		elsif($arr[4] =~ /(.+)\+.*/)
		{
		    $arr[4] = $1;
		}
		elsif($arr[4] =~ /.*\-(.+)/)
		{
		    $arr[4] = $1;
		}
		
	    }

	    $lab = $arr[$level * 2 + 2];

#	    if($level == 0)
#	    {
#	     	$lab =~ s/s//;
#		if($arr[4] ne "")
#		{
#		    $phn_lab = $arr[4];
#		}
#		$lab = "${phn_lab}__$lab";
#	    }
	}
	if(($lab ne "" || $l eq ".") && $plabel)
	{
	    print "$pstart $pstop $plabel\n";
	}
	if($lab ne "")
	{
	    $plabel = $lab;
	    $pstart = $start;
	}	
	$pstop = $stop;
	
    }
    while($l ne ".");
    print ".\n";
}

close MLF;