#!/bin/sh

# This script performs additional parameterisation. It takes
# pfiles with mel-banks and converts it to the targed format where
# the neural net is trained or evaluated on

if [ $# -lt 3 ] ; then
	echo USAGE: param_FN.sh config_file input_pfile output_pfile part{1, 2, 3}
	exit 1
fi

conf=$1
input=$2
output=$3
part=$4

#load configs
conf_path=${conf%\/*}
conf_global="$conf_path/_global.sh"

if [ -x $conf_global ] ; then
	source $conf_global
fi
if [ -x $conf ] ; then
	source $conf
fi

mkdir -p $out_dir/pfiles

param_done="no"

if [ "$system" = "STREAMS" ] ; then
	#echo ">>> $part"
	if [ `expr "${mfccer[$part]}" : ".*@.*"` = "0" ] ; then
		#echo ">>> ${bin_dir}/${mfccer[$part]} -i $input -o $output"
		${bin_dir}/${mfccer[$part]} -i $input -o $output
	else
		files=""
		i=0
		cmd=`${script_dir}/misc/parse_cmd.pl "${mfccer[$part]}" $i "@"`
		while [ "$cmd" != "" ] ; do
			file_ss=${output}.ss$i

			${bin_dir}/$cmd -i $input -o $file_ss

			files="$files $file_ss"
			i=$(($i + 1))
			cmd=`${script_dir}/misc/parse_cmd.pl "${mfccer[$part]}" $i "@"`
		done

		${bin_dir}/umerge -li 0 -o $output $files
		rm $files
	fi

	param_done="yes"
fi

if [ "$param_done" = "no" ] ; then
    echo ERROR: "The system is not set in the configuration file or the name is unknown."
    exit 1;
fi


