#!/usr/bin/perl

$pwd = `pwd`;
chomp $pwd;
$out = "";
$arg = "";

if($ARGV[7] eq "")
{
    print "\nParalel version of VTLN\n\n";
    print "Usage: pvtln.pl script_dir ncpu config tmp list_wav_mb hcopy mlf log sge_log\n\n";
    exit 1;
}

$script_dir=$ARGV[0];
$ncpu=$ARGV[1];
$cfg=$ARGV[2];
$tmp=$ARGV[3];
$list=$ARGV[4];
$hcopy_cfg=$ARGV[5];
$mlf=$ARGV[6];
$log=$ARGV[7];
$sge_log=$ARGV[8];
$"="";

# load filelist
open L, "$list" or die "ERROR: pvtln.pl - Can not open list-file: $list";
@l = <L>;
$all="@l";
$all =~ s/\n+/\n/g;
@l = split /\n/, $all;
$nfiles = @l;
close L;

# split the file list for separate cpus
$nchunk = int($nfiles / $ncpu);
$rem = $nfiles % $ncpu;

for($i = 0; $i < $ncpu; $i++)
{
    $ii = $i + 1;
    $part_list = "$list.$ii";
    
    if($part_list =~ /^.*\/([^\/]+)$/)
    {
	$part_list = $1;
    }
        
    $part_list = "$tmp/$part_list";

    $part_out = "$out.$i";
    
    if($part_out =~ /^.*\/([^\/]+)$/)
    {
	$part_out = $1;
    }

    $part_out = "$tmp/$part_out";

    system("mkdir -p $tmp");

    open OUT, ">$part_list" or die "ERROR: pvtln.pl - Can not create the list file: $part_list";

    $max = ($i < $rem ? $nchunk + 1 : $nchunk);
    for($j = 0; $j < $max && @l != 0; $j++)
    {
	if(@l == 0)
	{
	    break;
	}
	$f = pop @l;
	$f = "$pwd/$f" if(substr($f, 0, 1) ne "/");
	print OUT "$f\n";
    }
        close OUT;
}

$part_list =~ s/\.[^.]+$//;
$part_out =~ s/\.[^.]+$//;

$pid=$$;

$cmd = "unset JOB_ID
        unset SGE_TASK_ID
        unset SGE_TASK_FIRST
        unset SGE_TASK_LAST
        unset SGE_TASK_STEP
        unset JOB_NAME
        unset HOSTNAME
        echo $script_dir/vtln.sh $cfg $part_list.\\\$SGE_TASK_ID $hcopy_cfg $mlf $tmp/\\\$SGE_TASK_ID.log \\\> $tmp/\\\$SGE_TASK_ID.out > $tmp/pvtln$pid.cmd
        job_id=`qsub -t 1:$ncpu -V -N vtln -o $sge_log/stdout -e $sge_log/stderr $tmp/pvtln$pid.cmd | tr '.' ' ' | awk '{print \$3}'`

        while qstat -j \$job_id >& /dev/null ; do
                sleep 10s
        done
       ";

$cmd =~ s/\.\//$pwd\//g;

#print "$cmd";

system($cmd);
system("rm -f $log");

for($i = 0; $i < $ncpu; $i++)
{
    $ii = $i + 1;
    system("cat $tmp/$ii.log >> $log");
}

system("rm -f /tmp/pvtln$pid.cmd");
