#!/bin/sh

if [ $# -lt 4 ] ; then
	echo USAGE: streams_forward_pass_band.sh config_file input_pfile base_name_for_files stream{1-N}
	exit 1
fi

conf=$1
input=$2
name=$3
net_idx=$4

# SGE does not work with task_id 0
i=$(( $net_idx - 1 ))

# configuration
conf_path=${conf%\/*}
conf_global="$conf_path/_global.sh"

source $conf_global
source $conf

# check temp
work_dir=$out_dir
if [ $use_tmp == 1 ] ; then
	loc_tmp_dir="$tmp_dir/$$"                                              # /tmp/$user/$process_id
	mkdir -p $loc_tmp_dir
	free_space=`df $loc_tmp_dir | tail -n 1 | awk '{print int($4/1024)}'`  # in MB
	if [ $free_space -ge $tmp_min_space ] ; then
		work_dir=$loc_tmp_dir                                          # there is not enough space in the tmp
	fi
fi

mkdir -p $work_dir/pfiles
${script_dir}/param_FN.sh $conf $input $work_dir/pfiles/${name}_s${i}.pfile $net_idx
mkdir -p $out_dir/ffout

if [ "${is_net[$net_idx]}" != "0" ] ; then
    ${script_dir}/fwd_FN.sh $conf ${system}_s$i $out_dir/ffout/${name}_s$i.pfile $work_dir/pfiles/${name}_s${i}.pfile
    ${script_dir}/streams_postprocess_stream_posteriors.sh $conf $out_dir/ffout/${name}_s${i}.pfile $out_dir/ffout/${name}_s${i}_postpr.pfile $i
    rm -f $work_dir/pfiles/${name}_s${i}.pfile
else
    mv $work_dir/pfiles/${name}_s${i}.pfile $out_dir/ffout/${name}_s$i.pfile
    ${script_dir}/streams_postprocess_stream_posteriors.sh $conf $out_dir/ffout/${name}_s${i}.pfile $out_dir/ffout/${name}_s${i}_postpr.pfile $i
fi

if [ $use_tmp == 1 ] ; then
	rm -r -f $loc_tmp_dir
	if [ "`ls $tmp_dir`" == "" ] ; then
		rmdir $tmp_dir
	fi
fi
