#!/bin/sh

# This script merges band rabbin files into one pfile

if [ $# -lt 5 ] ; then
	echo USAGE: traps_merge_bands.ps config nstreams input_file_prefix input_file_suffix output_pfile [ref_labels]
	exit 1
fi

conf=$1
nstreams=$2
ifiles_preffix=$3
ifiles_suffix=$4
output=$5
labels=$6

#configuration
conf_path=${conf%\/*}
conf_global="$conf_path/_global.sh"

source $conf_global
source $conf

# path to this script
p=${0%\/*}

# create list of input files
input=""
for (( i=0 ; i < $nstreams ; i=i+1 )) ; do
	tr_idx=$(( $tr_idx + 1 ))

	file=${ifiles_preffix}${i}${ifiles_suffix}

	if [ "$input" != "" ] ; then
		input="$input "
	fi

	if [ "${transform[$tr_idx]}" != "" ] ; then
		input="$input${transform[$tr_idx]}_"
	fi

	if [ "$input" != "" ] ; then
		input="$input "
	fi

	input="$input$file"
done


# applay a transformation on merger streams
if [ "$final_tr" != "" ] ; then
	apply_tr="-tr $final_tr"
else
	apply_tr=""
fi


# decide whether to add labels or not
add_labels=""
if [ "$labels" != "" ] ; then
	add_labels="-l $labels";
fi

#echo "${bin_dir}/umerge $apply_tr -o $output $input $add_labels"
echo ${bin_dir}/umerge $apply_tr $merger_params -o $output $input $add_labels
nice -n 19 ${bin_dir}/umerge $apply_tr $merger_params -v -o $output $input $add_labels


# remove posteriors
if [ "$keep_train_band_posteriors" != "1" ] ; then
	rm -f ${ifiles_preffix%/*}/train_s*
fi

if [ "$keep_test_band_posteriors" != "1" ] ; then
	rm -f ${ifiles_preffix%/*}/test_s*
fi

if [ "$keep_cv_band_posteriors" != "1" ] ; then
	rm -f ${ifiles_preffix%/*}/cv_s*
fi
